routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Auth::routes();

Route::resource('users', \App\Http\Controllers\UserController::class)->only('index', 'show');

Route::resource('tasks', \App\Http\Controllers\TaskController::class)->except('create', 'index');

Route::resource('tags', \App\Http\Controllers\TagController::class)->except('show');
Route::get('/search/tag', [\App\Http\Controllers\TagController::class, 'search'])->name('tags.search');
Route::get('/tag_task/{task}', [\App\Http\Controllers\TagTaskController::class, 'index'])->name('tag_task.index');
Route::post('/tag_task', [\App\Http\Controllers\TagTaskController::class, 'store'])->name('tag_task.store');
Route::delete('/tag_task', [\App\Http\Controllers\TagTaskController::class, 'destroy'])->name('tag_task.destroy');


Route::get('/user_friend/read/{user}', [\App\Http\Controllers\UserFriendController::class, 'addReadFriend']);
Route::delete('/user_friend/read/{user}', [\App\Http\Controllers\UserFriendController::class, 'deleteReadFriend']);
Route::get('/user_friend/edit/{user}', [\App\Http\Controllers\UserFriendController::class, 'addEditFriend']);
Route::delete('/user_friend/edit/{user}', [\App\Http\Controllers\UserFriendController::class, 'deleteEditFriend']);

app/Models/Tag.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;

class Tag extends Model
{
    use HasFactory;

    protected $fillable = ['user_id', 'tag'];

    /**
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }


    /**
     * @return BelongsToMany
     */
    public function tasks(): BelongsToMany
    {
        return $this->belongsToMany(Task::class);
    }
}

app/Http/Controllers/TagController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\TagRequest;
use App\Http\Resources\TagResource;
use App\Models\Tag;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Http\Resources\Json\AnonymousResourceCollection;
use Illuminate\Support\Facades\Auth;

class TagController extends Controller
{

    public function __construct()
    {
        return $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|View
     */
    public function index(): Factory|View|Application
    {
        $tags = Auth::user()->tags;
        return view('tags.index', ['tags' => $tags]);

    }

    /**
     * @param Request $request
     * @return AnonymousResourceCollection
     */
    public function search(Request $request): AnonymousResourceCollection
    {
        $tags = Auth::user()->tags()->where('tag', 'LIKE', '%' . $request->get('search') . '%')->get();
        return TagResource::collection($tags);
    }

    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|View
     */
    public function create(): View|Factory|Application
    {
        return view('tags.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param TagRequest $request
     * @return RedirectResponse
     */
    public function store(TagRequest $request): RedirectResponse
    {
        $tag = Auth::user()->tags()->where('user_id', Auth::id())->where('tag', $request->get('tag'))->get();

        if (empty($tag)) {
            $tag = new Tag($request->all());
            $tag->user_id = Auth::id();
            $tag->save();
            return redirect()->route('tags.index')->with('success', 'Successfully created');
        } else {
            return redirect()->route('tags.index')->with('error', 'This tag is already exists!');
        }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Tag $tag
     * @return Application|Factory|View
     * @throws AuthorizationException
     */
    public function edit(Tag $tag): View|Factory|Application
    {
        $this->authorize('update', $tag);
        return view('tags.edit', ['tag' => $tag]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param TagRequest $request
     * @param Tag $tag
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function update(TagRequest $request, Tag $tag): RedirectResponse
    {
        $this->authorize('update', $tag);
        $tag->update($request->all());
        return redirect()->route('tags.index')->with('success', 'Successfully updated');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Tag $tag
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function destroy(Tag $tag): RedirectResponse
    {
        $this->authorize('delete', $tag);
        $tag->delete();
        return redirect()->route('tags.index')->with('success', 'Successfully deleted');
    }
}

resources/views/tags/create.blade.php
@extends('layouts.app')
@section('content')

    <form method="post" action="{{ route('tags.store') }}" enctype="multipart/form-data">
        @csrf
        <div class="mb-3">
            <label for="tag" class="form-label">Task</label>
            <input name="tag" value="{{ old('tag') }}" type="text"
                   class="form-control @if($errors->has('tag')) is-invalid @endif" id="tag">
            @error('tag')
            <p class="text-danger">{{$message}}</p>
            @enderror
        </div>
        <button type="submit" class="btn btn-primary">Create</button>
    </form>

@endsection

resources/views/tags/edit.blade.php
@extends('layouts.app')
@section('content')

    <form method="post" action="{{ route('tags.update', ['tag' => $tag]) }}" enctype="multipart/form-data">
        @csrf
        @method('PUT')
        <div class="mb-3">
            <label for="tag" class="form-label">Task</label>
            <input name="tag" value="{{ $tag->tag }}" type="text"
                   class="form-control @if($errors->has('tag')) is-invalid @endif" id="tag">
            @error('tag')
            <p class="text-danger">{{$message}}</p>
            @enderror
        </div>
        <button type="submit" class="btn btn-primary">Update</button>
    </form>

@endsection

resources/views/tags/index.blade.php
@extends('layouts.app')
@section('content')

    <h3>Create new tag <a class="btn btn-outline-primary" href="{{ route('tags.create') }}">Create</a></h3>
    <table class="table table-dark table-striped">
        <thead>
        <tr>
            <th scope="col">ID</th>
            <th scope="col">Tag</th>
            <th scope="col">Actions</th>
        </tr>
        </thead>
        <tbody id="tasks_list">
        @foreach($tags as $tag)
            @include('tags.tag', ['tag' => $tag])
        @endforeach
        </tbody>
    </table>
@endsection

resources/views/tags/tag.blade.php
<tr>
    <td>{{ $tag->id }}</td>
    <td class="w-50">{{ $tag->tag }}</td>
    <td class="d-flex">
        <form method="post" action="{{ route('tags.destroy', ['tag' => $tag]) }}">
            @csrf
            @method('DELETE')
            <button type="submit" class="btn btn-danger">Delete</button>
        </form>
        <a class="btn btn-outline-warning mx-1" href="{{route('tags.edit', ['tag' => $tag])}}">Edit</a>

    </td>
</tr>